# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

_Public Classes_

* [`metricbeat`](#metricbeat): Main class, includes all other classes

_Private Classes_

* `metricbeat::config`: This class handles the configuration file.
* `metricbeat::package`: This class handles metricbeat package.
* `metricbeat::service`: This class handles the metricbeat service.

**Defined types**

* [`metricbeat::module`](#metricbeatmodule): This defined type creates a new metricbeat module.

## Classes

### metricbeat

metricbeat

#### Parameters

The following parameters are available in the `metricbeat` class.

##### `package_name`

Data type: `String`

Name of the metricbeat package. Dfault value: 'metricbeat'.

##### `package_ensure`

Data type: `String`

State of package (e.g. present oder latest). Default value: 'present'.

##### `package_provider`

Data type: `Optional[String]`

Optional package provider for the package. Default value: Undef.

##### `package_source`

Data type: `Optional[String]`

Optional package source for the package. Default value: Undef.

##### `service_name`

Data type: `String`

Name of the metricbeat service. Default value: 'metricbeat'.

##### `service_ensure`

Data type: `Optional[String]`

Whether the metricbeat service should be running. Default value: 'running'.

##### `service_enable`

Data type: `Optional[Boolean]`

Whether the metricbeat service should be enabled. Default value: true.

##### `environment_file`

Data type: `String`

Path to the environment file for systemd. Default value: '/etc/sysconfig/metricbeat'.

##### `modules`

Data type: `Optional[Hash]`

An hash with enabled modules for metricbeat. Default value: {}.

##### `config`

Data type: `Optional[Hash]`

An hash with the main and output configuration. Default value: {}.

##### `env`

Data type: `Optional[Hash]`

An array with environment variables, wich will be written to the environment_file. Default value: [].

## Defined types

### metricbeat::module

This defined type creates a new metricbeat module.

#### Parameters

The following parameters are available in the `metricbeat::module` defined type.

##### `config`

Data type: `Array`

An array with module configurations.

